<template>
    <ion-select
        aria-label="Zařízení"
        label="Zařízení"
        placeholder="Vyberte zařízení"
        :multiple="true"
        v-model="model"
    >
        <ion-select-option
            v-for="device in deviceList"
            :key="device.id"
            :value="device.id"
            >({{
                [device.name, device.ip, device.mac]
                    .filter((v) => Boolean(v))
                    .join(', ')
            }})</ion-select-option
        >

        <ion-select-option disabled v-if="deviceList.length < 1"
            >Žádná zařízení</ion-select-option
        >
    </ion-select>
</template>

<script setup lang="ts">
import { DeviceEdge, Device_Filter } from '@/gql/graphql'
import { useUserStore } from '@/stores/userStore'
import { IonSelect, IonSelectOption } from '@ionic/vue'
import { useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed } from 'vue'

const userStore = useUserStore()

const model = defineModel({ required: true })

const filter = userStore.data.isAdmin ? Device_Filter.All : Device_Filter.My

const { result: deviceListResult } = useQuery(
    gql`
        query deviceListSelect($filter: DEVICE_FILTER!) {
            deviceList(first: 10000, filter: $filter) {
                edges {
                    node {
                        id
                        name
                        mac
                        ip
                    }
                }
            }
        }
    `,
    {
        filter,
    },
    { fetchPolicy: 'network-only' }
)

const deviceList = computed(() => {
    const edgeList = deviceListResult?.value?.deviceList?.edges
    return edgeList ? edgeList.map((edge: DeviceEdge) => edge.node) : []
})
</script>
